---
title: "Searches Customers by parameters"
url: "https://developer.retailexpress.com.au/apis/retail-express-api-21-v2/versions/210b509a-613e-44ac-a87b-ef6c22c23a2c/operations/get-customers"
---

> Full API specification: https://developer.retailexpress.com.au/apis/retail-express-api-21-v2/versions/210b509a-613e-44ac-a87b-ef6c22c23a2c.md

# Searches Customers by parameters

`GET` `/customers`

Operation ID: `get-customers`

Searches Customers by parameters

## Query parameters

- `created_since` (string, date-time, optional) - Created since
- `modified_since` (string, date-time, optional) - Modified since
- `order_by` (string, optional) - Order by. Available field name values: id, customer_number, first_name, last_name, full_name, company, date_of_birth, date_of_birth_withheld, customer_type_name, mobile, phone, email, acn, fax, website, account_customer_enabled, account_customer_payment_terms, account_customer_credit_blocked, account_customer_credit_limit, billing_address_line1, billing_address_line2, billing_address_suburb, billing_address_state, billing_address_postcode, billing_address_country, delivery_first_name, delivery_last_name, delivery_company, delivery_address_line1, delivery_address_line2, delivery_suburb, delivery_state, delivery_postcode, delivery_country, delivery_phone, delivery_mobile, loyalty_program_enabled, loyalty_points_available, loyalty_points_available_value, loyalty_points_redeemed, loyalty_points_to_date, receive_email, receive_post, receive_sms, price_group_standard, price_group_fixed, home_outlet_name, custom_reference, created_on, modified_on, export_to_web, sales_channel:id, survey:id Available direction values: id asc, customer_number desc. Example: id asc, supplier desc
- `filter_by` (string, optional) - Filter by. Available field name values: id, customer_number, first_name, last_name, full_name, company, date_of_birth, date_of_birth_withheld, customer_type_name, mobile, phone, email, acn, fax, website, account_customer_enabled, account_customer_payment_terms, account_customer_credit_blocked, account_customer_credit_limit, billing_address_line1, billing_address_line2, billing_address_suburb, billing_address_state, billing_address_postcode, billing_address_country, delivery_first_name, delivery_last_name, delivery_company, delivery_address_line1, delivery_address_line2, delivery_suburb, delivery_state, delivery_postcode, delivery_country, delivery_phone, delivery_mobile, loyalty_program_enabled, loyalty_points_available, loyalty_points_available_value, loyalty_points_redeemed, loyalty_points_to_date, receive_email, receive_post, receive_sms, price_group_standard, price_group_fixed, home_outlet_name, custom_reference, created_on, modified_on, export_to_web, sales_channel:id, survey:id In string values: '|' and ',' characters have to be escaped with slash, i.e. '\\,' '\\|' For operators that support multiple values (in, notin): multiple values are delimited using '|' character Available operators: eq - Equal neq - Not equals lt - Less lte - Less or equal gt - Greater gte - Greater or equal in - In notin - Not In contains - Contains isnull - Is Null isnullorempty - Is Null Or Empty isnotnull - Is Not Null startswith - Starts with endswith - Ends with doesnotcontain - Does not contain For non-nullable fields operators isnull and isnotnull are unavailable For dates operators: contains, startswith, endswith, doesnotcontain, isnullorempty are unavailable For strings operators: lt, lte, gt, gte are unavailable Example: id:eq:303062, sales_channel:3039:eq:true
- `page_number` (integer, int32, optional)
- `page_size` (integer, int32, optional)

## Header parameters

- `x-api-key` (string, required) - Api subscription key
- `Cache-Control` (string, optional)
- `Authorization` (string, required) - Bearer token for authorization (e.g., Bearer <token>)

## Responses

- `200` - Returns Customers
- `400` - Bad request
- `401` - Unauthorized
- `403` - Forbidden

## OpenAPI definition

```yaml
openapi: 3.0.1
info:
  title: Retail Express API
  version: v2.1
servers:
  - url: https://api.retailexpress.com.au/v2.1
paths:
  /customers:
    get:
      tags:
        - customers
      summary: Searches Customers by parameters
      description: Searches Customers by parameters
      operationId: get-customers
      parameters:
        - name: created_since
          in: query
          description: Created since
          schema:
            type: string
            description: Created since
            format: date-time
            nullable: true
        - name: modified_since
          in: query
          description: Modified since
          schema:
            type: string
            description: Modified since
            format: date-time
            nullable: true
        - name: order_by
          in: query
          description: "Order by. \r

            \r

            Available field name values: id, customer_number, first_name,
            last_name, full_name, company, date_of_birth,
            date_of_birth_withheld, customer_type_name, \r

            mobile, phone, email, acn, fax, website, account_customer_enabled,
            account_customer_payment_terms, account_customer_credit_blocked,
            account_customer_credit_limit, \r

            billing_address_line1, billing_address_line2,
            billing_address_suburb, billing_address_state,
            billing_address_postcode, billing_address_country,\r

            delivery_first_name, delivery_last_name, delivery_company,
            delivery_address_line1, delivery_address_line2, delivery_suburb,
            delivery_state, delivery_postcode, delivery_country, delivery_phone,
            delivery_mobile,\r

            loyalty_program_enabled, loyalty_points_available,
            loyalty_points_available_value, loyalty_points_redeemed,
            loyalty_points_to_date, \r

            receive_email, receive_post, receive_sms, price_group_standard,
            price_group_fixed, home_outlet_name, custom_reference, created_on,
            modified_on,\r

            export_to_web, sales_channel:id, survey:id\r

            \r

            Available direction values: id asc, customer_number desc. \r

            \r

            Example: id asc, supplier desc"
          schema:
            type: string
            description: "Order by. \r

              \r

              Available field name values: id, customer_number, first_name,
              last_name, full_name, company, date_of_birth,
              date_of_birth_withheld, customer_type_name, \r

              mobile, phone, email, acn, fax, website, account_customer_enabled,
              account_customer_payment_terms, account_customer_credit_blocked,
              account_customer_credit_limit, \r

              billing_address_line1, billing_address_line2,
              billing_address_suburb, billing_address_state,
              billing_address_postcode, billing_address_country,\r

              delivery_first_name, delivery_last_name, delivery_company,
              delivery_address_line1, delivery_address_line2, delivery_suburb,
              delivery_state, delivery_postcode, delivery_country,
              delivery_phone, delivery_mobile,\r

              loyalty_program_enabled, loyalty_points_available,
              loyalty_points_available_value, loyalty_points_redeemed,
              loyalty_points_to_date, \r

              receive_email, receive_post, receive_sms, price_group_standard,
              price_group_fixed, home_outlet_name, custom_reference, created_on,
              modified_on,\r

              export_to_web, sales_channel:id, survey:id\r

              \r

              Available direction values: id asc, customer_number desc. \r

              \r

              Example: id asc, supplier desc"
            nullable: true
        - name: filter_by
          in: query
          description: "Filter by. \r

            \r

            Available field name values: id, customer_number, first_name,
            last_name, full_name, company, date_of_birth,
            date_of_birth_withheld, customer_type_name, \r

            mobile, phone, email, acn, fax, website, account_customer_enabled,
            account_customer_payment_terms, account_customer_credit_blocked,
            account_customer_credit_limit, \r

            billing_address_line1, billing_address_line2,
            billing_address_suburb, billing_address_state,
            billing_address_postcode, billing_address_country,\r

            delivery_first_name, delivery_last_name, delivery_company,
            delivery_address_line1, delivery_address_line2, delivery_suburb,
            delivery_state, delivery_postcode, delivery_country, delivery_phone,
            delivery_mobile,\r

            loyalty_program_enabled, loyalty_points_available,
            loyalty_points_available_value, loyalty_points_redeemed,
            loyalty_points_to_date, \r

            receive_email, receive_post, receive_sms, price_group_standard,
            price_group_fixed, home_outlet_name, custom_reference, created_on,
            modified_on,\r

            export_to_web, sales_channel:id, survey:id\r

            \            \r

            In string values: '|' and ',' characters have to be escaped with
            slash, i.e. '\\\\,' '\\\\|'\r

            \            \r

            For operators that support multiple values (in, notin): multiple
            values are delimited using '|' character\r

            \r

            Available operators:\r

            \r

            eq -  Equal\r

            \r

            neq - Not equals\r

            \r

            lt  - Less\r

            \r

            lte - Less or equal\r

            \r

            gt -  Greater\r

            \r

            gte - Greater or equal\r

            \r

            in  - In\r

            \r

            notin - Not In\r

            \            \r

            contains - Contains\r

            \r

            isnull - Is Null\r

            \            \r

            isnullorempty - Is Null Or Empty\r

            \r

            isnotnull - Is Not Null\r

            \r

            startswith - Starts with\r

            \r

            endswith - Ends with\r

            \r

            doesnotcontain - Does not contain\r

            \            \r

            For non-nullable fields operators isnull and isnotnull are
            unavailable\r

            \r

            For dates operators: contains, startswith, endswith, doesnotcontain,
            isnullorempty are unavailable\r

            \            \r

            For strings operators: lt, lte, gt, gte are unavailable\r

            \            \r

            Example: id:eq:303062, sales_channel:3039:eq:true"
          schema:
            type: string
            description: "Filter by. \r

              \r

              Available field name values: id, customer_number, first_name,
              last_name, full_name, company, date_of_birth,
              date_of_birth_withheld, customer_type_name, \r

              mobile, phone, email, acn, fax, website, account_customer_enabled,
              account_customer_payment_terms, account_customer_credit_blocked,
              account_customer_credit_limit, \r

              billing_address_line1, billing_address_line2,
              billing_address_suburb, billing_address_state,
              billing_address_postcode, billing_address_country,\r

              delivery_first_name, delivery_last_name, delivery_company,
              delivery_address_line1, delivery_address_line2, delivery_suburb,
              delivery_state, delivery_postcode, delivery_country,
              delivery_phone, delivery_mobile,\r

              loyalty_program_enabled, loyalty_points_available,
              loyalty_points_available_value, loyalty_points_redeemed,
              loyalty_points_to_date, \r

              receive_email, receive_post, receive_sms, price_group_standard,
              price_group_fixed, home_outlet_name, custom_reference, created_on,
              modified_on,\r

              export_to_web, sales_channel:id, survey:id\r

              \            \r

              In string values: '|' and ',' characters have to be escaped with
              slash, i.e. '\\\\,' '\\\\|'\r

              \            \r

              For operators that support multiple values (in, notin): multiple
              values are delimited using '|' character\r

              \r

              Available operators:\r

              \r

              eq -  Equal\r

              \r

              neq - Not equals\r

              \r

              lt  - Less\r

              \r

              lte - Less or equal\r

              \r

              gt -  Greater\r

              \r

              gte - Greater or equal\r

              \r

              in  - In\r

              \r

              notin - Not In\r

              \            \r

              contains - Contains\r

              \r

              isnull - Is Null\r

              \            \r

              isnullorempty - Is Null Or Empty\r

              \r

              isnotnull - Is Not Null\r

              \r

              startswith - Starts with\r

              \r

              endswith - Ends with\r

              \r

              doesnotcontain - Does not contain\r

              \            \r

              For non-nullable fields operators isnull and isnotnull are
              unavailable\r

              \r

              For dates operators: contains, startswith, endswith,
              doesnotcontain, isnullorempty are unavailable\r

              \            \r

              For strings operators: lt, lte, gt, gte are unavailable\r

              \            \r

              Example: id:eq:303062, sales_channel:3039:eq:true"
            nullable: true
        - name: page_number
          in: query
          schema:
            maximum: 100000
            minimum: 1
            type: integer
            format: int32
        - name: page_size
          in: query
          schema:
            maximum: 2147483647
            minimum: 1
            type: integer
            format: int32
        - name: x-api-key
          in: header
          description: Api subscription key
          required: true
          schema:
            type: string
        - name: Cache-Control
          in: header
          required: false
          schema:
            type: string
            default: no-cache
        - name: Authorization
          in: header
          required: true
          description: Bearer token for authorization (e.g., Bearer <token>)
          schema:
            type: string
      responses:
        "200":
          description: Returns Customers
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/Customer.PagingResponse"
              example:
                data:
                  - account_customer:
                      credit_blocked: true
                      credit_limit: 0
                      credit_remaining: 0
                      enabled: true
                      payment_terms: 0
                    acn: string
                    billing_address:
                      country: string
                      country_code: string
                      state: string
                      suburb: string
                      address_line1: string
                      address_line2: string
                      postcode: string
                      first_name: string
                      last_name: string
                    company: string
                    customer_number: string
                    customer_type:
                      id: 0
                      name: string
                    date_of_birth: string
                    date_of_birth_withheld: true
                    delivery_addresses:
                      - country: string
                        country_code: string
                        state: string
                        suburb: string
                        address_line1: string
                        address_line2: string
                        postcode: string
                        company: string
                        mobile: string
                        phone: string
                        first_name: string
                        last_name: string
                        id: 0
                        default: true
                        modified_on: string
                    email: string
                    fax: string
                    first_name: string
                    id: 0
                    last_name: string
                    loyalty_program:
                      enabled: true
                      points_available: 0
                      points_redeemed: 0
                      points_to_date: 0
                      auto_price_group: true
                      points_available_value: 0
                    marketing:
                      receive_email: true
                      receive_post: true
                      receive_sms: true
                    mobile: string
                    phone: string
                    price_groups:
                      - id: 0
                        name: string
                        type: string
                    survey_responses:
                      - id: 0
                        question: string
                        answer: string
                    website: string
                    home_outlet:
                      id: 0
                      name: string
                      modified_on: string
                    custom_reference: string
                    export_to_web: true
                    total_payments: 0
                    total_transactions: 0
                    sales_channels:
                      - id: 0
                        name: string
                        shopify_channel: true
                        enabled: true
                    created_on: string
                    modified_on: string
                page_number: 0
                page_size: 0
                total_records: 0
        "400":
          description: Bad request
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ProblemDetails"
              example:
                type: string
                title: string
                status: 0
                detail: string
                instance: string
        "401":
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ProblemDetails"
              example:
                type: string
                title: string
                status: 0
                detail: string
                instance: string
        "403":
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/ProblemDetails"
              example:
                type: string
                title: string
                status: 0
                detail: string
                instance: string
security: []
components:
  schemas:
    Customer.PagingResponse:
      title: ""
      type: object
      properties:
        data:
          type: array
          items:
            $ref: "#/components/schemas/Customer"
          nullable: true
        page_number:
          type: integer
          format: int32
        page_size:
          type: integer
          format: int32
        total_records:
          type: integer
          format: int32
      additionalProperties: false
    ProblemDetails:
      title: ""
      type: object
      properties:
        type:
          type: string
          nullable: true
        title:
          type: string
          nullable: true
        status:
          type: integer
          format: int32
          nullable: true
        detail:
          type: string
          nullable: true
        instance:
          type: string
          nullable: true
      additionalProperties: {}
    Customer:
      title: ""
      type: object
      properties:
        account_customer:
          $ref: "#/components/schemas/AccountCustomer"
        acn:
          type: string
          description: Acn
          nullable: true
        billing_address:
          $ref: "#/components/schemas/CustomerBillingAddress"
        company:
          type: string
          description: Company
          nullable: true
        customer_number:
          type: string
          description: Customer number
          nullable: true
        customer_type:
          $ref: "#/components/schemas/CustomerType"
        date_of_birth:
          type: string
          description: Date of birth
          nullable: true
        date_of_birth_withheld:
          type: boolean
          description: Date of birth with held
        delivery_addresses:
          type: array
          items:
            $ref: "#/components/schemas/DeliveryAddress"
          description: Delivery address
          nullable: true
        email:
          type: string
          description: Email
          nullable: true
        fax:
          type: string
          description: Fax
          nullable: true
        first_name:
          type: string
          description: First name
          nullable: true
        id:
          type: integer
          description: Identifier
          format: int32
        last_name:
          type: string
          description: Last name
          nullable: true
        loyalty_program:
          $ref: "#/components/schemas/LoyaltyProgram"
        marketing:
          $ref: "#/components/schemas/Marketing"
        mobile:
          type: string
          description: Mobile
          nullable: true
        phone:
          type: string
          description: Phone
          nullable: true
        price_groups:
          type: array
          items:
            $ref: "#/components/schemas/PriceGroup"
          description: Price group
          nullable: true
        survey_responses:
          type: array
          items:
            $ref: "#/components/schemas/SurveyResponse"
          description: Survey responses
          nullable: true
        website:
          type: string
          description: Website
          nullable: true
        home_outlet:
          $ref: "#/components/schemas/OutletExtended"
        custom_reference:
          type: string
          description: Custom reference
          nullable: true
        export_to_web:
          type: boolean
          description: Export to web
        total_payments:
          type: number
          description: Total Payments
          format: double
          nullable: true
        total_transactions:
          type: integer
          description: Total Transactions
          format: int32
          nullable: true
        sales_channels:
          type: array
          items:
            $ref: "#/components/schemas/CustomerSalesChannel"
          description: Sales Channels
          nullable: true
        created_on:
          type: string
          description: Created on
          format: date-time
        modified_on:
          type: string
          description: Modified on
          format: date-time
      additionalProperties: false
      description: Customer model
    AccountCustomer:
      title: ""
      type: object
      properties:
        credit_blocked:
          type: boolean
          description: Is credit blocked
        credit_limit:
          type: number
          description: Credit limit
          format: double
        credit_remaining:
          type: number
          description: Credit remaining
          format: double
          nullable: true
        enabled:
          type: boolean
          description: Is enabled
        payment_terms:
          type: integer
          description: Payment terms
          format: int32
          nullable: true
      additionalProperties: false
      description: Account customer view model
    CustomerBillingAddress:
      title: ""
      type: object
      properties:
        country:
          type: string
          description: Country
          nullable: true
        country_code:
          type: string
          description: Country Code
          nullable: true
        state:
          type: string
          description: State
          nullable: true
        suburb:
          type: string
          description: Suburb
          nullable: true
        address_line1:
          type: string
          description: Address line 1
          nullable: true
        address_line2:
          type: string
          description: Address line 2
          nullable: true
        postcode:
          type: string
          description: Post code
          nullable: true
        first_name:
          type: string
          description: First name
          nullable: true
        last_name:
          type: string
          description: Last Name
          nullable: true
      additionalProperties: false
      description: Billing address model
    CustomerType:
      title: ""
      type: object
      properties:
        id:
          type: integer
          description: Customer type identifier
          format: int32
        name:
          type: string
          description: Customer type name
          nullable: true
      additionalProperties: false
      description: Customer type model
    DeliveryAddress:
      title: ""
      type: object
      properties:
        country:
          type: string
          description: Country
          nullable: true
        country_code:
          type: string
          description: Country Code
          nullable: true
        state:
          type: string
          description: State
          nullable: true
        suburb:
          type: string
          description: Suburb
          nullable: true
        address_line1:
          type: string
          description: Address line 1
          nullable: true
        address_line2:
          type: string
          description: Address line 2
          nullable: true
        postcode:
          type: string
          description: Post code
          nullable: true
        company:
          type: string
          description: Company
          nullable: true
        mobile:
          type: string
          description: Mobile phone
          nullable: true
        phone:
          type: string
          description: Phone
          nullable: true
        first_name:
          type: string
          description: First name
          nullable: true
        last_name:
          type: string
          description: Last Name
          nullable: true
        id:
          type: integer
          description: Identifier
          format: int32
        default:
          type: boolean
          description: Is Default
          nullable: true
        modified_on:
          type: string
          description: Modified on
          format: date-time
      additionalProperties: false
      description: Delivery Address model
    LoyaltyProgram:
      title: ""
      type: object
      properties:
        enabled:
          type: boolean
          description: Is enabled
        points_available:
          type: number
          description: Points available
          format: double
        points_redeemed:
          type: number
          description: Points redeemed
          format: double
        points_to_date:
          type: number
          description: Points to date
          format: double
        auto_price_group:
          type: boolean
          description: Auto price group
        points_available_value:
          type: number
          description: Points available value
          format: double
          nullable: true
      additionalProperties: false
      description: Loyalty program model
    Marketing:
      title: ""
      type: object
      properties:
        receive_email:
          type: boolean
          description: Receive email
        receive_post:
          type: boolean
          description: Receive post
        receive_sms:
          type: boolean
          description: Receive sms
      additionalProperties: false
      description: Marketing view model
    PriceGroup:
      title: ""
      type: object
      properties:
        id:
          type: integer
          description: Identifier
          format: int32
        name:
          type: string
          description: Name
          nullable: true
        type:
          type: string
          description: Type
          nullable: true
      additionalProperties: false
      description: Price group model
    SurveyResponse:
      title: ""
      type: object
      properties:
        id:
          type: integer
          description: Survey response id
          format: int32
        question:
          type: string
          description: Survey response question
          nullable: true
        answer:
          type: string
          description: Survey response answer
          nullable: true
      additionalProperties: false
      description: Survey Response model
    OutletExtended:
      title: ""
      type: object
      properties:
        id:
          type: integer
          description: Outlet id
          format: int32
          nullable: true
        name:
          maxLength: 255
          minLength: 0
          type: string
          description: Outlet name
          nullable: true
        modified_on:
          type: string
          description: Modified on
          format: date-time
      additionalProperties: false
    CustomerSalesChannel:
      title: ""
      type: object
      properties:
        id:
          type: integer
          description: Identifier
          format: int32
        name:
          type: string
          description: Channel name
          nullable: true
        shopify_channel:
          type: boolean
          description: Is shopify channel
        enabled:
          type: boolean
          description: Is enabled
      additionalProperties: false
      description: CustomerSalesChannel Model
```
